#include <STC12C5A.H>
#define uint unsigned int
#define uchar unsigned char
uchar drive;

sbit rst = P1^0;		//λ,0λ
sbit ce = P1^1;		//Ƭѡ
sbit dc  = P1^2;		//1дݣ0дָ
sbit din = P1^3;	//
sbit clk = P1^4;	//ʱ
sbit ligh = P1^5;	//

void forward()
{	
	CCAP0H=0;  //  ռձȿ
	CCAP1H=0;  //  ռձȿ
	P2=0XFA;	
}	//11111010
void back()
{	
	CCAP0H=0;  //  ռձȿ
	CCAP1H=0;  //  ռձȿ
	P2=0XF5;	
}	//11110101
void left()
{	
	CCAP0H=0;  //  ռձȿ
	CCAP1H=64;  //  ռձȿ
	P2=0XF6;	
}	//11110110
void right()
{	
	CCAP0H=64;  //  ռձȿ
	CCAP1H=0;  //  ռձȿ
	P2=0XF9;
}	//11111001
void stop()
{	
	CCAP0H=0;  //  ռձȿ
	CCAP1H=0;  //  ռձȿ
	P2=0XFF;	
}	//11111111
void delay5ms(void)   // -0.000000000001us
{
    unsigned char a,b,c;
    for(c=199;c>0;c--)
        for(b=120;b>0;b--)
            for(a=1;a>0;a--);
}
void delay100us(void)   // -0.083188657407us
{
    unsigned char a,b;
    for(b=141;b>0;b--)
        for(a=7;a>0;a--);
}
void pwminit()
{
	CCON=0;	   //PCAʼ
	CL=0;	  //PCA16λͰλ
	CH=0;	  //PCA16λ߰λ
	CMOD=0x00;	//ѡ ϵͳʱ/12 Ϊ,PWMƵf=sysclk/256/12;

	CCAP0H=0x80;  //  ռձȿ
	CCAP0L=0x80;
	CCAP1H=0x80;  //  ռձȿ
	CCAP1L=0x80;
	PCA_PWM0=0x00; //ռձȵĵھλΪ0
	PCA_PWM1=0x00; //ռձȵĵھλΪ0
	CCAPM0=0x42;  //P13ΪPWM
	CCAPM1=0x42;  //P14ΪPWM
	CR=1;	 //PCA
}
void init()
{
    uchar k;
	TMOD=0x20;//öʱ1Ϊʽ2
	TH1=0xFD;
	TL1=TH1;
	SCON=0x50;
    PCON=0x00;
	TR1=1;
	EA=1;
	ES=1;
}
void main()
{
	init();
	pwminit();	
	while(1)
	{	
		switch(drive)
		{
			case '2':LCD_write_hanzi(0,0,0);
					LCD_write_hanzi(2,0,1);break;
			case '8':LCD_write_hanzi(0,0,2);	 
					LCD_write_hanzi(2,0,3);break;
			case '4':LCD_write_hanzi(0,0,6);
					LCD_write_hanzi(2,0,8);break;
			case '6':LCD_write_hanzi(0,0,7);
					LCD_write_hanzi(2,0,8);break;
			case '5':LCD_write_hanzi(0,0,4);
					LCD_write_hanzi(2,0,5);break;
		}
	}		
}	
void ckzd() interrupt 4
{
	drive=SBUF;
	switch(drive)
	{
		case '2':forward();break;
		case '8':back();break;
		case '4':left();break;
		case '6':right();break;
		case '5':stop();break;
	}
	RI=0;						
}